7144175 samba service enters maintenance mode after SIGKILL
authorVladimir Marek <Vladimir.Marek@oracle.com>
Sat, 05 May 2012 01:17:31 -0700
changeset 878 f5bfc829326f
parent 877 b1a9a2c48018
child 879 67d6be565620
7144175 samba service enters maintenance mode after SIGKILL
components/samba/samba/Solaris/samba.sh
components/samba/samba/Solaris/samba.xml
components/samba/samba/Solaris/winbind.xml
components/samba/samba/Solaris/wins.xml
components/samba/samba/samba.p5m
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/components/samba/samba/Solaris/samba.sh	Sat May 05 01:17:31 2012 -0700
@@ -0,0 +1,64 @@
+#!/sbin/sh
+
+#
+# CDDL HEADER START
+#
+# The contents of this file are subject to the terms of the
+# Common Development and Distribution License (the "License").
+# You may not use this file except in compliance with the License.
+#
+# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+# or http://www.opensolaris.org/os/licensing.
+# See the License for the specific language governing permissions
+# and limitations under the License.
+#
+# When distributing Covered Code, include this CDDL HEADER in each
+# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+# If applicable, add the following below this CDDL HEADER, with the
+# fields enclosed by brackets "[]" replaced with your own identifying
+# information: Portions Copyright [yyyy] [name of copyright owner]
+#
+# CDDL HEADER END
+#
+
+#
+# Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
+#
+
+. /lib/svc/share/smf_include.sh
+
+SAMBA_CONFIG=/etc/samba/smb.conf
+
+case "$1" in
+	start)
+		if [ ! -f "$SAMBA_CONFIG" ]; then
+			echo "Configuration file '$SAMBA_CONFIG' does not exist."
+			exit 1
+		fi
+
+		# Command to execute is found in second and further script arguments
+		shift
+		eval "[email protected]"
+		;;
+	stop)
+		# kill whole contract group
+
+		# first send TERM signal and wait 30 seconds
+		smf_kill_contract $2 TERM 1 30
+		ret=$?
+		[ $ret -eq 1 ] && exit 1
+
+		# If there are still processes running, KILL them
+		if [ $ret -eq 2 ] ; then
+			smf_kill_contract $2 KILL 1
+		fi
+		;;
+	*)
+		cat <<-EOT
+			Usage:
+			  $0 start <command to run>
+			  $0 stop <contract number to kill>
+		EOT
+		exit 1
+		;;
+esac
--- a/components/samba/samba/Solaris/samba.xml	Fri May 04 23:07:52 2012 -0700
+++ b/components/samba/samba/Solaris/samba.xml	Sat May 05 01:17:31 2012 -0700
@@ -23,7 +23,7 @@
 -->
 <!DOCTYPE service_bundle SYSTEM "/usr/share/lib/xml/dtd/service_bundle.dtd.1">
 <!--
-	Copyright (c) 2006, 2011, Oracle and/or its affiliates. All rights reserved.
+	Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
 
 	#ident	"@(#)samba.xml	1.6	10/07/26 SMI"
 
@@ -67,11 +67,11 @@
 	</dependent>
 
 	<exec_method type='method' name='start'
-		exec='/usr/sbin/smbd -D'
+		exec='/lib/svc/method/samba start /usr/sbin/smbd -D'
 		timeout_seconds='170' />
 
 	<exec_method type='method' name='stop'
-		exec='/usr/bin/kill `cat /var/samba/locks/smbd.pid`'
+		exec='/lib/svc/method/samba stop %{restarter/contract}'
 		timeout_seconds='60' />
 
 	<stability value='Unstable' />
--- a/components/samba/samba/Solaris/winbind.xml	Fri May 04 23:07:52 2012 -0700
+++ b/components/samba/samba/Solaris/winbind.xml	Sat May 05 01:17:31 2012 -0700
@@ -23,7 +23,7 @@
 -->
 <!DOCTYPE service_bundle SYSTEM "/usr/share/lib/xml/dtd/service_bundle.dtd.1">
 <!--
-	Copyright (c) 2006, 2011, Oracle and/or its affiliates. All rights reserved.
+	Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
 
 	#ident	"@(#)winbind.xml	1.2	10/07/26 SMI"
 
@@ -72,11 +72,11 @@
 	</dependent>
 
 	<exec_method type='method' name='start'
-		exec='/usr/sbin/winbindd'
+		exec='/lib/svc/method/samba start /usr/sbin/winbindd -D'
 		timeout_seconds='60' />
 
 	<exec_method type='method' name='stop'
-		exec='/usr/bin/kill `/usr/bin/cat /var/samba/locks/winbindd.pid`'
+		exec='/lib/svc/method/samba stop %{restarter/contract}'
 		timeout_seconds='60' />
 
 	<stability value='Unstable' />
--- a/components/samba/samba/Solaris/wins.xml	Fri May 04 23:07:52 2012 -0700
+++ b/components/samba/samba/Solaris/wins.xml	Sat May 05 01:17:31 2012 -0700
@@ -23,7 +23,7 @@
 -->
 <!DOCTYPE service_bundle SYSTEM "/usr/share/lib/xml/dtd/service_bundle.dtd.1">
 <!--
-	Copyright (c) 2006, 2011, Oracle and/or its affiliates. All rights reserved.
+	Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
 
 	#ident	"@(#)wins.xml	1.2	10/07/26 SMI"
 
@@ -67,11 +67,11 @@
 	</dependent>
 
 	<exec_method type='method' name='start'
-		exec='/usr/sbin/nmbd -D'
+		exec='/lib/svc/method/samba start /usr/sbin/nmbd -D'
 		timeout_seconds='60' />
 
 	<exec_method type='method' name='stop'
-		exec='/usr/bin/kill `cat /var/samba/locks/nmbd.pid`'
+		exec='/lib/svc/method/samba stop %{restarter/contract}'
 		timeout_seconds='60' />
 
 	<stability value='Unstable' />
--- a/components/samba/samba/samba.p5m	Fri May 04 23:07:52 2012 -0700
+++ b/components/samba/samba/samba.p5m	Sat May 05 01:17:31 2012 -0700
@@ -57,6 +57,7 @@
 dir path=lib
 dir path=lib/svc
 dir path=lib/svc/manifest
+dir path=lib/svc/manifest/method
 dir path=lib/svc/manifest/network
 dir path=usr group=sys
 dir path=usr/bin
@@ -154,6 +155,7 @@
 #
 file Solaris/pam.conf-winbind path=etc/pam.conf-winbind
 file path=etc/samba/smb.conf-example
+file Solaris/samba.sh path=lib/svc/method/samba
 file Solaris/samba.xml path=lib/svc/manifest/network/samba.xml \
      restart_fmri=svc:/system/manifest-import:default
 file Solaris/swat.xml path=lib/svc/manifest/network/swat.xml \